import os
import math
import sys
import csv
import time
import argparse
import pathlib
import script_unpack # TODO: think this causes an empty print?

# TODO: maybe unify this with repack.py

parser = argparse.ArgumentParser(description='performs script_unpack.py over an entire folder')
parser.add_argument('-f', '--filter', type=str, help='only unpack scripts with filenames containing the given string')
parser.add_argument('-i', '--config', type=pathlib.Path, help='config file for script_unpack.py')
parser.add_argument('input_path', type=pathlib.Path, help='path to original script folder')
parser.add_argument('output_path', type=pathlib.Path, help='path to output script folder')
args = parser.parse_args()

def unpack_all(args):
    start_time = time.time()

    for filename in os.listdir(args.input_path):
        if len(filename) < 2:
            continue # lazy skip for "."

        if args.filter and args.filter not in filename:
            continue

        f = pathlib.Path(os.path.join(args.input_path, filename))
        f2 = pathlib.Path(os.path.join(args.output_path, filename) + ".csv")
        unpackArgs = argparse.Namespace(input_path=f, output_path=f2)
        if args.config:
            unpackArgs.config = args.config
        
        script_unpack.unpack(unpackArgs) # TODO: consider try-catching this

    print("All script unpacking complete in %s seconds." % (time.time() - start_time))

unpack_all(args)