import os
import math
import sys
import argparse
import pathlib
import time

start_time = time.time()

# search the raw script of the game for the input string
# the string is converted into shift-jis bytes, with english text being full-width'd
# note the string is case sensitive, of course

parser = argparse.ArgumentParser(description='searches all raw Doozy-J scripts for the given string')
parser.add_argument('search_path', type=pathlib.Path, help='path to search within (not recursively)')
parser.add_argument('search_string', type=pathlib.Path, help='string to search for')
# TODO: default fullwidths the string
args = parser.parse_args()

# thanks https://stackoverflow.com/questions/2422177/python-how-can-i-replace-full-width-characters-with-half-width-characters
HALF2FULL = dict((i, i + 0xFEE0) for i in range(0x21, 0x7F))
HALF2FULL[0x20] = 0x3000
def fullen(s):
    '''
    Convert all ASCII characters to the full-width counterpart.
    '''
    return str(s).translate(HALF2FULL)

def searchForRawString(text):
    text = fullen(text)
    print("Searching for: " + text)
    shiftJisString = text.encode('shift-jis')

    fileList = []
    for filename in os.listdir(search_path):
        f = os.path.join(search_path, filename)
        if os.path.isfile(f) and len(filename) > 0:
            in_file = open(f, "rb")
            data = in_file.read()
            in_file.close()

            if shiftJisString in data:
                print("Match in: " + f)

search_path = args.search_path
searchForRawString(args.search_string)

print("String search complete in %s seconds." % (time.time() - start_time))